//Global variables
window.onLoadCodes = [];
window.rowCounter = 0;
window.isGridFocused = false;
window.name="search";

function addLoadHandler( strLoadHandler )
{
    window.onLoadCodes[ window.onLoadCodes.length ] = strLoadHandler;
}
function onLoad()
{
    eval( window.onLoadCodes.join(";") );
}

function appendGridRow( strConfidence, strHits, strTopic )
{
    var oTBody = document.getElementById("contentHolder");
    var oRow   = document.createElement("TR");
    var oCell1 = document.createElement("TD");
    var oCell2 = document.createElement("TD");
    var oCell3 = document.createElement("TD");
    
    oCell1.innerHTML = "<nobr>"+strConfidence+"</nobr>";
    oCell2.innerHTML = "<nobr>"+strHits+"</nobr>";
    oCell3.innerHTML = "<nobr>"+strTopic+"</nobr>";
    oRow.className = "GRID_R";
    oRow.onclick = onRowClick;
    oRow.id = window.rowCounter++;
    oRow.appendChild(oCell1);
    oRow.appendChild(oCell2);
    oRow.appendChild(oCell3);
    oTBody.appendChild(oRow);
}
function clearGridContent( )
{
    var oTBody = document.getElementById("contentHolder");
    while( oTBody.firstChild )
    {
        oTBody.removeChild( oTBody.firstChild );
    }    
    window.rowCounter = 0;
}
function setStatusMessage( strStatusText )
{
    var objStatusString = document.getElementById("statusString");
    objStatusString.innerHTML = "<nobr>"+strStatusText+"</nobr>";
}

function selectRow( objRow )
{
    objRow = objRow || ( window.isGridFocused ? this : null );
    if(objRow && objRow.tagName == "TR")
    {
        var hdn = document.getElementById("selectedRow");
        if(hdn)
        {
            var objOldRow = document.getElementById(hdn.value);
            if(objOldRow && objOldRow != objRow)
            {
                objOldRow.className = "GRID_R";
            }
            objRow.className = window.isGridFocused ? "GRID_R_S" : "GRID_R_SG";
            hdn.value = objRow.id;
        }
    }
}

function doGridFocus()
{
    var objFocusHolder = document.getElementById("focusHolder");
    if( objFocusHolder )
    {
        objFocusHolder.focus();
    }
}

function onRowClick()
{
    objRow = this;
    if (objRow )
    {
        selectRow( objRow );
    }
    displayTopic( objRow );
}

function onGridFocus()
{
    window.isGridFocused = true;
    var objRow = getSelectedRow();
    if( !objRow )
    {
        var oTBody = document.getElementById("contentHolder");
        objRow = oTBody.firstChild;
    }
    if( objRow )
    {
        selectRow( objRow );
    }
}

function onGridBlur()
{
    window.isGridFocused = false;
    var objRow = getSelectedRow();
    if( objRow )
    {
        selectRow( objRow );
    }
    window.setTimeout("document.getElementById(\"criteriaEdit\").focus()", 10);
}

function onEditKeyDown(event)
{
    if( event.keyCode == 0xD ) //ENTER key
    {
        startSearch();
    }
}


function onGridKeyDown(event)
{
    switch( event.keyCode )
    {
        case 0x26 : //UP ARROW key
            {
                var objSelectedRow = getSelectedRow();
                if( objSelectedRow && objSelectedRow.previousSibling )
                {
                    selectRow(objSelectedRow.previousSibling);
                    setRowVisible(objSelectedRow.previousSibling);
                }
            } 
            break;
        case 0x28 : //DOWN ARROW key 
            {
                var objSelectedRow = getSelectedRow();
                if( objSelectedRow && objSelectedRow.nextSibling )
                {
                    selectRow(objSelectedRow.nextSibling);
                    setRowVisible(objSelectedRow.nextSibling);
                }
            } 
            break;
        case 0xD :  //ENTER key
            {
                displayTopic( getSelectedRow() );
            }
            break;
        default:
            // do nothing
    }
}

function setRowVisible( objRow )
{
    var objScroller = document.getElementById("scroller");
    var objContentHolder = document.getElementById("contentHolder");
    var objFirstRow = objContentHolder.firstChild;
    while( objFirstRow.tagName != "TR" )
    {
        objFirstRow = objFirstRow.nextSibling;
    }
    if( objScroller && objRow )
    {
        if( objScroller.scrollTop + objFirstRow.offsetTop > objRow.offsetTop )
        {
            if(objRow == objFirstRow)
            { 
                objScroller.scrollTop = 0;
            }
            else
            {
                objScroller.scrollTop = objRow.offsetTop;
            }
        }
        else if( objScroller.scrollTop + objScroller.clientHeight < objRow.offsetTop + objRow.offsetHeight)
        {
            objScroller.scrollTop = objRow.offsetTop + objRow.offsetHeight - objScroller.clientHeight; 
        }
    }
}

function getSelectedRow()
{
    var hdn = document.getElementById("selectedRow");
    if(hdn)
    {
        return document.getElementById(hdn.value) || null;
    }
    return null;
}

function startSearch()
{
    var objCriteriaEdit = document.getElementById("criteriaEdit");
    var objSearchApplet = document.getElementById("searchApplet");
    if ( objCriteriaEdit && objSearchApplet )
    {
        var hdn = document.getElementById("selectedRow");
        if(hdn)
        {
            hdn.value = "-1";
        }
        clearGridContent();
        objSearchApplet.startSearch( objCriteriaEdit.value );
    }
}

function displayTopic( objRow )
{
    var objSearchApplet = document.getElementById("searchApplet");
    if(objRow && objSearchApplet)
    {
        var iRowId = parseInt( objRow.id );
        if( !isNaN(iRowId) && iRowId >=0 )
        {
            objSearchApplet.displayTopic( iRowId );
        }
    }
}
